// This program performs the simple test shown in the
// RROS YouTube Video

#Include "RROScommands.bas"
#Include "InitializationRoutines.bas"
gosub InitRROScommands
gosub InitRoboClawRobot

Main:
  rCommand(ExpansionSetup,ARM) 
  delay 3000
  gosub InitArm 
  PosData[2]=0
  gosub MoveArm
  gosub OpenHand
  PosData[0]=200
  PosData[1]=170  
  gosub MoveArm
  gosub CloseHand
  PosData[0]=180
  PosData[1]=190 
  gosub MoveArm
  PosData[0]=40
  gosub MoveArm
  PosData[0]=60
  PosData[1]=150
  gosub MoveArm
  gosub Drop
  gosub ParkArm
end
  


InitArm:
  //        shoulder  elbow  wrist  rotate   o/c
  data ParkData; 250,   250,   240,     0,    0
  data MinData;  130,    50,    50,     0,    0
  data MaxData;   70,    80,    80,    70,   80
  data PosData;  250,   250,   240,     0,    0 // start out at park data
  rCommand(SetServoIndex,0)  
  for i=0 to 4 
    rCommand(SetServoMin,MinData[i])
  next
  //rCommand(SetServoIndex,0)  // NOTE: not needed HERE because index rolls to beginning
  for i=0 to 4 
    rCommand(SetServoMax,MaxData[i])
  next
  //rCommand(SetServoIndex,0)  
  for i=0 to 4 
    rCommand(SetServoPosition,ParkData[i])
  next
  // assuming default speed of 1 for each joint
  rCommand(EnableServos,2)
return
 
ParkArm:
  rCommand(EnableServos,1)
  rCommand(SetServoIndex,0)
  for i=0 to 4 // no wrist
    rCommand(SetServoPosition,ParkData[i])
  next  
  delay 6000
  rCommand(EnableServos,0)
return

MoveArm:
  rCommand(EnableServos,1)
  rCommand(SetServoIndex,0)
  for i=0 to 2 // just shoulder,elbow,wrist
    rCommand(SetServoPosition,PosData[i])
  next
  delay 4000
  //rCommand(EnableServos,0)
return   

OpenHand:
  rCommand(EnableServos,1)
  rCommand(SetServoIndex,4)
  rCommand(SetServoPosition,200)
  delay 3000
  //rCommand(EnableServos,0)
return

CloseHand:
  rCommand(EnableServos,1)
  rCommand(SetServoIndex,4)
  rCommand(SetServoPosition,20)
  delay 3000
  //rCommand(EnableServos,0)
return

Drop:
  rCommand(EnableServos,1)
  rCommand(SetServoIndex,4)
  rCommand(SetServoPosition,150)
  delay 3000
  //rCommand(EnableServos,0)
return

