#include "RROScommands.bas"
gosub InitRROScommands
/**************************************************************************
 * Normally, you would #include the InitializationRoutines.bas file here  *
 * and then call the appropriate routine for your robot.  The standard    *
 * RB-9 init routine does not include the compass (because it would cause *
 * the program to 'hang' if no compass is pressent.  Rather than change   *
 * that standard routine, this program includes a copy of the RB-9 init   *
 * routine with the compass included.  It is suggested that you modify    *
 * the initialization routines you use so they match your specific        *
 * hardware.                                                              *
 *                                                                        *
 * This program rotates the robot until it finds a large object. When one *
 * is found, the robot moves to it.                                       *
 **************************************************************************/


MainProgram:
  REAL=false // change to true if a real robot is being used
  gosub Init
  //rCommand(CalibrateCompass,0) 
  gosub FaceNorth 
  repeat
    done = false
    repeat  // look for a nearby object
      rTurn 1 
    until rRange()<150
    delay 2000  // delay when object found
    A1=rCompass()
    repeat
      rTurn 1 
    until rRange()>150  // keep turning until past object 
    delay 2000  // delay when object no longer seen
    A2=rCompass()
    TotAngle = A2-A1
    if TotAngle>180 then TotAngle = 360-A2+A1
    if TotAngle >45  // large object found
      // face object
      rTurn -TotAngle/2 
      // go to object
      while rRange()>20
        rForward 1
        done = true
      wend
    endif
  until done
end

Init:
  if REAL
    gosub InitRB9robot // use a routine for your robot (or modify this one)  
  else
    gosub DrawObjects
    // init the simulator
    rlocate 400,300,random(360)
    rSpeed 10
  endif
return

FaceNorth:
  if REAL
    rCommand(TurnToHalfAngle,0)
  else
    while rCompass()!=0
      if rCompass()>180
        rTurn 1
      else
        rTurn -1
      endif
    wend
  endif
  delay 3000
return

DrawObjects:
  Linewidth 10
  SetColor Blue
  Line 300,340,250,250
  circlewh 400,400,10,10
  circlewh 500,300,30,30
  Line 600,500,700,450
return

InitRB9robot:
  // modify everything as necessary to match your hardware
  rCommport 47 // change to the virtual port used for your Bluetooth device
  SetTimeOut 50000
  rlocate 0,0 // 255,0 if communication delay is needed
  rCommand(MotorSetup,SMALLDC+ENCODERS) 
  rCommand(SensorSetup,SR04+FIVERANGE+HMC6352)
  rCommand(SetMotorRamp,5)
  rCommand(SetClicksPerDiam,160)
  rCommand(SetClicksPer90,110) 
  rCommand(SetReducForwRight,0)
  rCommand(SetReducForwLeft,15)
  rCommand(SetReducBackRight,0)
  rCommand(SetReducBackLeft,0)
  //rCommand(SetRotationTime,18) 
  //rCommand(SetMoveTime,12) 
  rCommand(SetSpeed,35) 
  rCommand(SetSlowDownSpeed,30)
  rCommand(SetSlowDown2,25) 
  rCommand(SetCCdivisor,3)
  rCommand(SetBumpDist,10)
  rCommand(SetProxDist,15)
  rCommand(EnableCounters,1)
  rCommand(SetRobotAngle,90/2)
  rCommand(SetTurnStyle,100)
  rCommand(SetRROStimeout,15)
  rCommand(SetTurnToMin,45)   // turn to speed must be FASTER because of
  rCommand(SetTurnToMax,70)  // the delay to read the compass
  rCommand(SetRobotDiameter,18) // calibrates rRange to pixel measurements
return



