#include "RROScommands.bas"  // path necessary if not in same directory as program
#include "InitializationRoutines.bas"
gosub InitRROScommands
Real=true // set to true to use REAL robot, false for simulation
BeaconNum = Yellow // beacon color (or number) to detect

// Initialize the simulator OR the real robot
if Real
  // gosub appropriate init routine
  // for YOUR robot
  // below are samples that I used (choose 1)
  gosub InitServoRobot
  //gosub InitRoboClawRobot
  //gosub InitDCrobot
else
  rLocate 400,300
  x=10
  oldx=x
  y=10
  oldy=y
  d=0  
endif

rCommand(SetRobotDiameter,0) // make range readings in 1/4 inch units (the default)

xyString 1,480,"Bumpers          Feel            Line"
xyString 335,480, "         Range(front)     Compass"         
xyString 720,480,"Beacon"

while(1)
  xyString 20,500,rBumper();"";rFeel();"";rSense();"";rRange(0);"";rCompass();" ";rBeacon(BeaconNum),"    "
  rForward 0
  ReadMouse x,y,b
  if(!Real)
    rLocate 400,300,d
    rInvisible BeaconNum
    call DrawCircle(oldx,oldy,20,white,white)  
    call DrawCircle(x,y,20,black,BeaconNum)
    oldx=x
    oldy=y
  endif
  if b=1  // left button
      if Real 
        rTurn -10
      else
        d--
      endif
  endif
  if b=2  // right button
      if Real 
        rTurn 10
      else
        d++
      endif
  endif
wend

sub DrawCircle(x,y,r,c,cc)
  LineWidth 3
  Circle x-r,y-r,x+r,y+r,c,cc
return



